#include "robbolito.h"

type_pawn_value *pawn_zobrist;
static void pawn_zobrist_initialization()
    {
    pawn_zobrist = malloc(list_pawn_number * sizeof(type_pawn_value));
    memset(pawn_zobrist, 0, list_pawn_number * sizeof(type_pawn_value));
    }
void gain_reset()
    {
    int i, j;

    for ( j = 0; j < 0x10; j++ )
        for ( i = 0; i < 07777; i++ )
            maximum_positional_gain[j][i] = 0;
    }
void history_reset()
    {
    int piece, qu;

    for ( piece = 0; piece < 16; piece++ )
        for ( qu = A1; qu <= H8; qu++ )
            history_value[piece][qu] = 0x800;
    }

int main()
    {
    PRINTF("%s\n", NAME);
    PRINTF("%s\n", "by bankuss & kranium");
    pawn_zobrist_initialization();
    initialization_zobrist(64);
    history_reset();
    initialization_capture();
    pile_initialization();
    pawn_initialization();
    initialization_value();
    static_initialization();
    game_new(TRUE);

    while( 1 )
        input_console();
    return 0;
    }
